from gint import *
import random as r
from leaf import leaf
from char import char

# CONSTANT
TILEW = 12
TILEH = 14
MAXX = DWIDTH // TILEW
MAXY = DHEIGHT // TILEH
# game state
x = 4
y = 7
leaves = set()

def titlescreen():
    dclear(C_WHITE)
    dupdate()
    dtext(5,5,C_BLACK,"press any key")
    dupdate()

def draw_bg():
    dclear(C_RGB(2,15,2))

def draw_fg(n):
    s = "Day: " + str(n+1)
    dtext(1,1, C_BLACK, s)

def draw_leaves():
    for l in leaves:
        dimage(l[0] * TILEW, l[1] * TILEH, leaf)

def draw_char():
    dimage(x * TILEW, y * TILEH, char)

def creates_leaves(n):
    while len(leaves) < n:
        leaves.add((r.randrange(MAXX),r.randrange(MAXY)))

def next_day(n):
    dclear(C_WHITE)
    dtext(5,5,C_BLACK,"Continue to next day ?")
    dupdate()
    ev = getkey()
    return ev.key != KEY_EXIT

def launch():
    dclear(C_WHITE)
    dupdate()
    #ev = getkey()
    game()

def game():
    i=0
    c=True
    creates_leaves(10)
    while c:
        while len(leaves) != 0:
            draw_game(i)
            gameloop()
        i+=1
        c = next_day(i)
        creates_leaves(10+i)

def draw_game(n):
    draw_bg()
    draw_leaves()
    draw_char()
    draw_fg(n)
    dupdate()
    
def gameloop():
    global x, y
    while (ev := pollevent()).type != KEYEV_NONE:
        if ev.type in  [KEYEV_DOWN, KEYEV_HOLD]:
            if ev.key == KEY_UP:
                if y > 0:
                        y = (y - 1) 
            elif ev.key == KEY_DOWN:
                    if y < MAXY-1:
                        y = (y + 1) 
            elif ev.key == KEY_LEFT:
                    if x > 0:
                        x = (x - 1) 
            elif ev.key == KEY_RIGHT:
                    if x < MAXX-1: 
                        x = (x + 1) 
            elif ev.key == KEY_SHIFT:
                    swipe()

def swipe():
    global leaves
    if (x,y) in leaves:
        leaves.remove((x,y))


keep_running = True
while keep_running:
    titlescreen()
    ev = getkey()

    if ev.key == KEY_EXIT:
        keep_running = False
    else:
        launch()
